#define MIDIMSG2(stat, data1) (DWORD)((stat) | ((data1) << 8))
#define MIDIMSG3(stat, data1, data2) (DWORD)((stat) | ((data1) << 8) | ((data2) << 16))

#define SwapDword(data) (*((BYTE*)(data) + 0) << 24 | *((BYTE*)(data) + 1) << 16 | *((BYTE*)(data) + 2) << 8 | *((BYTE*)(data) + 3))
#define SwapWord(data) (*((BYTE*)(data) + 0) << 8 | *((BYTE*)(data) + 1))

typedef struct
{
	BYTE* data;
	DWORD size;
}CHUNK;

typedef struct _tag_EVENTLIST
{
	DWORD duration;
	DWORD time;
	BYTE status;
	BYTE* data;
	DWORD size;
	struct _tag_EVENTLIST* next;
}EVENT;

typedef struct
{
	BYTE* data;
	DWORD size;

	EVENT* start;
	EVENT* stop;

	EVENT* events;
	DWORD dbase;
	DWORD gbase;
}SMAF;

typedef struct
{
	BYTE bm;
	BYTE bl;
	BYTE pc;

	BYTE lfo;
	BYTE pan;
	BOOL pe;
	BYTE alg;
}CHPARAM;

typedef struct
{
				// max val
	BYTE multi;	//15
	BYTE dt;	//7
	BYTE ar;	//15
	BYTE dr;	//15
	BYTE sr;	//15
	BYTE rr;	//15
	BYTE sl;	//15
	BYTE tl;	//63
	BYTE ksl;	//3
	BYTE dam;	//3
	BYTE dvb;	//3
	BYTE fb;	//7
	BYTE ws;	//31

	BOOL xof;
	BOOL sus;
	BOOL ksr;
	BOOL eam;
	BOOL evb;
}OPPARAM;
